var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import autobahn from "autobahn";
import { WampMessageType } from "./models/WampMessageType";
import { WampSubscriptionList } from "./WampSubscriptionList";
// tslint:disable-next-line:no-var-requires
var uniqid = require("uniqid");
var WampConnection = /** @class */ (function () {
    function WampConnection(options) {
        var _this = this;
        this.isAlive = false;
        this.connect = function () {
            return new Promise(function (resolve) {
                if (_this.session) {
                    console.info("Already connected");
                    _this.isAlive = true;
                    resolve();
                }
                _this.connection = new autobahn.Connection(_this.options);
                _this.connection.onopen = function (autobahnSession) {
                    _this.isAlive = true;
                    _this.session = autobahnSession;
                    console.info("Connected");
                    resolve();
                };
                _this.connection.onclose = function (reason, details) {
                    _this.isAlive = false;
                    _this.session = null;
                    if (reason === "details") {
                        console.warn("Connection closed");
                    }
                    else {
                        console.error("Connection lost, details: [" + JSON.stringify(details) + "]");
                    }
                    return true;
                };
                _this.connection.open();
            });
        };
        this.close = function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.unsubscribeFromAll()];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, this.connection.close()];
                }
            });
        }); };
        this.send = function (_a) {
            var topic = _a.topic, type = _a.type, callback = _a.callback, id = _a.id;
            switch (type) {
                case WampMessageType.Subscribe:
                    return _this.subscribe(topic, callback);
                case WampMessageType.Unsubscribe:
                    return _this.unsubscribe(topic, id);
                case WampMessageType.SubscribeToAll:
                    return _this.subscribeToAll();
                case WampMessageType.UnsubscribeFromAll:
                    return _this.unsubscribeFromAll();
                case WampMessageType.GetAllSubscriptions:
                    return new Promise(function (resolve) {
                        resolve(_this.getAllSubscriptions());
                    });
                case WampMessageType.GetSubscription:
                    return new Promise(function (resolve) {
                        resolve(_this.getSubscription(id));
                    });
            }
            return new Promise(_this.catchUnknownType);
        };
        this.isConnected = function () { return _this.isAlive; };
        this.subscribe = function (topic, callback) { return __awaiter(_this, void 0, void 0, function () {
            var subscription, id, subscriptionItem;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.session.subscribe(topic, callback)];
                    case 1:
                        subscription = _a.sent();
                        id = uniqid();
                        subscriptionItem = this.subscriptionList.add(id, subscription, topic);
                        return [2 /*return*/, Promise.resolve(subscriptionItem)];
                }
            });
        }); };
        this.unsubscribe = function (topic, id) { return __awaiter(_this, void 0, void 0, function () {
            var subscriptionItem;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        subscriptionItem = this.subscriptionList.find(id);
                        if (!subscriptionItem) {
                            return [2 /*return*/, Promise.reject(topic + " is not initialized")];
                        }
                        return [4 /*yield*/, subscriptionItem.subscription.unsubscribe()];
                    case 1:
                        _a.sent();
                        this.subscriptionList.remove(id);
                        return [2 /*return*/, Promise.resolve()];
                }
            });
        }); };
        this.unsubscribeFromAll = function () {
            var unsubscriptionPromises = [];
            _this.subscriptionList
                .getAll()
                .forEach(function (subscriptionItem) {
                return unsubscriptionPromises.push(_this.unsubscribe(subscriptionItem.topic, subscriptionItem.id));
            });
            return Promise.all(unsubscriptionPromises);
        };
        this.subscribeToAll = function () {
            var subscriptionPromises = [];
            _this.subscriptionList
                .getAll()
                .forEach(function (subscriptionItem) {
                return subscriptionPromises.push(_this.subscribe(subscriptionItem.topic, subscriptionItem.subscription.handler));
            });
            return Promise.all(subscriptionPromises);
        };
        this.getAllSubscriptions = function () { return _this.subscriptionList.getAll(); };
        this.getSubscription = function (id) { return _this.subscriptionList.find(id); };
        this.catchUnknownType = function () { return "You've sent unknown type of message"; };
        this.subscriptionList = new WampSubscriptionList();
        this.options = options;
    }
    return WampConnection;
}());
export { WampConnection };
//# sourceMappingURL=WampConnection.js.map