import { IConnectionOptions } from "autobahn";
import { IProxy } from "socket-connection";
import { WampMessageType } from "./models/WampMessageType";
export interface IWampMessageOptions {
    type: WampMessageType;
    topic?: string;
    callback?: () => void;
    id?: string;
}
export declare class WampConnection implements IProxy {
    private subscriptionList;
    private session;
    private isAlive;
    private connection;
    private options;
    constructor(options: IConnectionOptions);
    connect: () => Promise<{}>;
    close: () => Promise<void>;
    send: ({ topic, type, callback, id }: IWampMessageOptions) => Promise<any>;
    isConnected: () => boolean;
    private subscribe;
    private unsubscribe;
    private unsubscribeFromAll;
    private subscribeToAll;
    private getAllSubscriptions;
    private getSubscription;
    private catchUnknownType;
}
